#!/usr/bin/perl

                         ### *** IMPORTANT *** ###

       ### *** Make sure the path to PERL above is correct *** ###


      #################################################################
      #                                                               #
      #                       100 Links Ver 2.2                       #
      #                                                               #
      #                   Free for all Links Program                  #
      #                              by                               #
      #                        Ranson Johnson                         #
      #                                                               #
      # E-Mail: ranson@rlaj.com                                       #
      #                                                               #
      # Script name: preview.cgi                                      #
      #                                                               #
      # Copywrite 1997/1998 by Ranson's Scripts all rights reserved   #
      # Sale or re-distribution of this program without prior written #
      # permision is prohibited.                                      #
      #                                                               #
      #################################################################


                      ### *** IMPORTANT *** ###

### *** If FTP'ing this file, be sure to send in ASCII format *** ###

# You must chmod the cgi's to 755 
# For information on chmod see Ranson's FAQ's

        ## You should'nt need to change anything below ##

push(@INC,"./");
require ("100-setup.pl");


# Get the input
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});

# Split the name-value pairs
@pairs = split(/&/, $buffer);

foreach $pair (@pairs) {
   ($name, $value) = split(/=/, $pair);

   # Un-Webify plus signs and %-encoding
   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $value =~ s/<!--(.|\n)*-->//g;

   if ($allow_html != 1) {
      $value =~ s/<([^>]|\n)*>//g;
   }

   $FORM{$name} = $value;
}

$FORM{'disc'} =~ s/\cM//g;
$FORM{'disc'} =~ s/\n\n/<P>/gi;
$FORM{'disc'} =~ s/\n/<BR>/g;


                         ### *** *** ###


open (FILE, "$Link_Log");
while (<FILE>) {

 if (/$FORM{'url'}/o)  { &already_there; }
close (FILE); 
}


                         ### *** *** ###

open (FILE, "$bad_word_log");
@BADLINES=<FILE>;
close(FILE);

$desc = "$FORM{'disc'}";
@desc = split(/ /, $desc);

$site = "$FORM{'sitename'}";
@site = split(/ /, $site);


foreach $badword(@BADLINES) {

foreach $discword(@desc) {
 if ($badword =~ /\b$discword\b/i)  { &bad_words($badword); }
 }
foreach $siteword(@site) {
 if ($badword =~ /\b$siteword\b/i)  { &bad_words($badword); }
 }
}
                         ### *** *** ###

                         ### *** *** ###

$myurl = $FORM{'url'};
$myurl =~ s/http:\/\///g;
$myurl =~ s/\.com.+//g;
$myurl =~ s/\.net.+//g;

open (FILE, "$black_list");
@LINES=<FILE>;
close(FILE);

foreach $line(@LINES) {
 if ($line =~ /$myurl/i) { &black_list; }
}


                         ### *** *** ###



&no_url unless $FORM{'url'};
&no_comments unless $FORM{'disc'};
&no_name unless $FORM{'sitename'};
&no_email unless $FORM{'emailadd'};
&no_valid_email unless (($FORM{'emailadd'} eq '') || (($FORM{'emailadd'} ne '') &&
($FORM{'emailadd'} =~ /\w*@\w*/))); 

################## PREVIEW OF USERS URL INFORMATION ##############

$disc = (substr($FORM{'disc'},0,$desc_length));
    
     print "Content-type: text/html\n\n";

	print  "<title>Preview of $FORM{'sitename'}'s entry</title>\n";
        print  "<HTML><HEAD></HEAD>\n";
        print  "<BODY BGCOLOR=FFFFFF>\n";
        print  "<H2>Please check your entry for accuracy</H2>\n";
        print  "<HR>\n";
        print  "The information you entered is:<P>\n";
	print  "<B><a href=\"$FORM{'url'}\" Target=\"New\">\n";
	print  "$FORM{'sitename'}\n";
	print  "</A>\n";
	print  "<BR>\n";
	print  "$disc\n";
	print  "<BR>";
	print  "</B><P>\n";
	print "<B>Check your URL and make sure it works.</B><BR>\n";
        print  "If everything is correct, then press the submit\n";
        print  "button below.<BR><B>If you need to correct something use\n";
        print  "the BACK BUTTON on your browser</B> to go back to the form \n";
        print  "and correct the information.<P>\n";

                  ######### FORM HIDDEN VALUES #########

    print  "<FORM METHOD=\"POST\" ACTION=\"add.cgi\">\n";
    
    print "<input type=\"hidden\" name=\"sitename\" value=\"$FORM{'sitename'}\">\n";
    print "<input type=\"hidden\" name=\"url\" value=\"$FORM{'url'}\">\n";
    print "<input type=\"hidden\" name=\"emailadd\" value=\"$FORM{'emailadd'}\">\n";
    print "<input type=\"hidden\" name=\"disc\" value=\"$disc\">\n";
    print  "<INPUT TYPE=\"SUBMIT\" VALUE=\"Submit Entry\">\n";
    print  "</FORM></BODY></HTML>\n";
       



#######################
# Subroutines
 

sub no_comments {
   print "Content-type: text/html\n\n";
   print "<html><head><title>No Discription</title></head>\n";
   print "<body><h1>Your Discription appears to be blank</h1>\n";
   print " and therefore your Link was not\n";
   print "added.  Please use the <B> BACK BUTTON</B> on your browser to Go Back\n";
   print " and enter your site discription.<p>\n";
   print "\n</body></html>\n";
  

  

   exit;
}

sub already_there {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Already on file</title></head>\n";
   print "<body><H2>Your Url \n";
   print "<a href=\"$FORM{'url'}\">$FORM{'url'}</A><BR>\n";
   print " is already listed on the 100 Links page\n";
   print " and therefore your link was not added.</H2>\n";
   print "<P>If you feel this is in error, please send us\n";
   print "<a href=\"mailto:$webmaster\"> Email</A> and we will look into\n";
   print " the problem\n"; 
   print "</body></html>\n";

   

   exit;
}


sub no_url {
   print "Content-type: text/html\n\n";
   print "<html><head><title>No URL</title></head>\n";
   print "<body><h1>Your Site Address (URL) appears to be blank</h1>\n";
   print " and therefore your Link was not\n";
   print "added.  Please use the <B> BACK BUTTON</B> on your browser to Go Back\n";
   print " and enter your Full URL.<p>\n";
   print "\n</body></html>\n";

exit;
}


sub no_name {
   print "Content-type: text/html\n\n";
   print "<html><head><title>No Site Name</title></head>\n";
   print "<body><h1>Your Site Name appears to be blank</h1>\n";
   print " and therefore your Link was not\n";
   print "added.  Please use the <B> BACK BUTTON</B> on your browser to Go Back\n";
   print " and enter your Site Name.<p>\n";
   print "\n</body></html>\n";

exit;
}

sub no_email {
   print "Content-type: text/html\n\n";
   print "<html><head><title>No Email Address</title></head>\n";
   print "<body><h1>Your Email Address appears to be blank</h1>\n";
   
   print "Please use the <B> BACK BUTTON</B> on your browser to Go Back\n";
   print " and enter your Email Address.<p>\n";
   print "\n</body></html>\n";

   exit;
}

# Subroutine for error in email address
sub no_valid_email
{
   print "Content-type: text/html\n\n";
   print "<html><head><title>Invalid E-Mail Address</title></head>\n";
   print "<body>\n";
   print "<h2>Invalid E-Mail Address</h2>\n";
   print "You must specify a valid email address.\n";
   print "Please use the <B> BACK BUTTON</B> on your browser to Go Back\n";
   print " and enter your Email Address.<p>\n";
   print "</body></html>\n";

   exit;
} 
  
sub black_list {
   print "Content-type: text/html\n\n";
   print "<html><head><title>Black List</title></head>\n";
   print "<body><H2>Your site \n";
   print "<a href=\"$FORM{'url'}\">$FORM{'sitename'}</A><BR>\n";
   print " has been Black Listed\n";
   print " and therefore your Site was not added</H2>\n";
   print "<P>If you feel this is in error, please send us\n";
   print "<a href=mailto:\"$webmaster\"> Email</A> and we will look into\n";
   print " the problem\n"; 
   print "</body></html>\n";

exit;
}


sub bad_words {

local ($word) = @_;

   print "Content-type: text/html\n\n";
   print "<html><head><title>Bad Words</title></head>\n";
   print "<body><H2>You have used language that is not allowed, \n";
   print " and therefore your Site was not added. - $badword</H2>\n";
   print "</body></html>\n";

exit;
}	