#!/usr/bin/perl

                         ### *** IMPORTANT *** ###

       ### *** Make sure the path to PERL above is correct *** ###


      #################################################################
      #                                                               #
      #                       100 Links Ver 2.2                       #
      #                                                               #
      #                   Free for all Links Program                  #
      #                              by                               #
      #                        Ranson Johnson                         #
      #                                                               #
      # E-Mail: ranson@rlaj.com                                       #
      #                                                               #
      # Script name: 100-setup.pl                                     #
      #                                                               #
      # Copywrite 1997/1998 by Ranson's Scripts all rights reserved   #
      # Sale or re-distribution of this program without prior written #
      # permision is prohibited.                                      #
      #                                                               #
      #################################################################


                      ### *** IMPORTANT *** ###

### *** If FTP'ing this file, be sure to send in ASCII format *** ###

# You must chmod the cgi's to 755 
# For information on chmod see Ranson's FAQ's

#  Configure the varialbles in the configuration section below
#    be careful to not disturb the single (') or double quotes (") 
#    surounding each variable, or the semicolon (;) at the end of 
#    each line.

# The 'Path' to the files, so Perl can find, them is essential.
# The path below is - /usr/var/www/docs/rlaj/scripts/100links/
# Help with the path on your server can be found at:
# http://www.rlaj.com/scripts/faq/install.htm


# This program is set up for Unix mail - Sendmail - /usr/sbin/sendmail
# And NT mail gateways
#                       blat
#                       windmail
#                       imail
#
# If the mail program is not in the path for your server, then
#
# ASK YOUR SERVER ADMINISTRATOR FOR THE PATH AND NAME OF THE MAIL PROGRAM
#
# We can not help with this.



# Recommended directory structure on the server is as follows:

# cgi-bin/
#	|
#	|
#	100links/
#		|
#		|
#		- 100link.cgi
#		- add.cgi
#		- 100-admin.cgi
#		- 100-setup.pl (this file)
#		- preview.cgi
#		- tmp_link.log
#		- badword.log
#		- blk_list.log
#		- pg_count.log
#		- referer.log
#
#
#                          ### *** *** ###
#
# Your_home_directory/
#	|
#	|
#	100links/
#		|
#		|
#		- top.htm
#		- bottom.htm
#		- ALL THE IMAGES YOU ARE GOING TO USE FOR THIS PROGRAM


                          ### *** *** ###


#             ### *** CONFIGURATION SECTION *** ###


# Enter the operating system for your server
# Unix = '0' 
# NT = '1'
$operating_system = '0';


# Enter the title for your 100 Links - try to keep this short 3 to 5 words
$page_title = "100 Links Page"; 


                      ### *** Mail *** ###


# Where is your servers mail program? 
# (the address below usually works on UNIX)
$mailprog = '/usr/sbin/sendmail';

# If you want an E-Mail when someone makes an entry, enter your E-Mail
$webmaster = 'ranson@rlaj.com';

# Enter your E-Mail address or a return address for mail to the user
$return_add = 'webmaster@rlaj.com';

# Enter your mail subject
$mail_subject = '100 Links Page';

# Do you want an email each time someone makes an entry to you page? 
$webmaster_mail = '0';    # 1 = Yes; 0 = No

# Do you want to send the user an E-Mail reciept? (handy for return links)
$remote_mail = '1';       # 1 = Yes; 0 = No 



                 ### *** Paths to Files *** ###

# For Path help - see: http://www.rlaj.com/scripts/faq/paths.html

# Enter the full path to the page you will be using for the top of
# the 100link.cgi - This page controls the colors for your page, your
# logo, and any other information you want at the top of the 100 links 
$link_top_page = '/usr/var/www/docs/rlaj/scripts/100links/top.htm';

# Enter the full path to the page you will be using for the bottom
# of the 100 links page - This can be a copyright statement, additional
# links, or anything you want at the bottom of the page.
$link_bottom_page = '/usr/var/www/docs/rlaj/scripts/100links/bottom.htm';

    
# Enter the full path to the log file that stores the links
$Link_Log = "/usr/home/rlaj/cgi-bin/100links/tmp_link.log";

# Enter the full path to the blk_list.log file
$black_list = "/usr/home/rlaj/cgi-bin/100links/blk_list.log";

# Enter the full path to the blk_list.log file
$bad_word_log = "/usr/home/rlaj/cgi-bin/100links/badword.log";

# Enter the full path to the pg_count.log
$count_log = "/usr/home/rlaj/cgi-bin/100links/pg_count.log";

# Enter the full path to the referer.log
$referer_log = '/usr/home/rlaj/cgi-bin/100links/referer.log';

                ### *** Web Addresses *** ###


# Enter the web address of your links page - 100link.cgi
$Links_cgi = "http://www.rlaj.com/cgi-rlaj/100links/100link.cgi";


########################## Set Options  ##################################

# What kind of separator do you want between entries
$separator = '0';         # 1 = <HR> 0 = <P>

# Do you want to send the user back to the links page after they post? 
# If no, they will see a thank you screen.
$redirect = '1';          # 1 = Yes; 0 = No

# Do you want to allow HTML within the description of the site?
$allow_html = '1';        # 1 = Yes; 0 = No


# Do you want to allow posting to your links page form outside your site?
# Sometimes other sites will copy your form and place it on their site, or
# the mass submit sites will spam your page.
$allow_outside_posting = '0';        # 1 = Yes; 0 = No

# Set the length of the description for each listing 
# set at 300 charactors now - about 60 words
$desc_length = '300';

                         ### *** *** ###

# please leave a link to the scirpts page
$scripts_page = "<CENTER>This 100 links program designed by Ranson and is available <A HREF=\"http://www.rlaj.com/scripts\"> Here</A></CENTER>";


                         ### *** *** ###
                         ### *** *** ###
                         ### *** *** ###


sub open_error
    {

    local ($errorname) = @_;
    print "Content-Type: text/html\n\n";
    print <<"EOT";
<HTML>
<HEAD>
<TITLE>Open Error!</TITLE>
</HEAD>
<BODY BGCOLOR=#FFFFFF Link=#0000FF vlink=#1D307E>
<P>
<HR>
<P>
<H1>Error!</H1>
<P>
<H4>The $this_cgi can not find, or is not able to open the 
specified file:</H4>
<H3>$errorname</H3>
<P>
<B>  
Please check the path and file name in $ENV{'SCRIPT_NAME'}.
<P>
Also check the file permissions (chmod) for the file.
<P>
</BODY>
</HTML>

EOT

exit;
} # End sub open_error

                         ### *** *** ###


sub send_mail {    ### *** Unix Mail *** ###

if (($operating_system eq '0') && ($remote_mail eq "1")) {

                     ### *** Send Mail To User *** ###

        open (MAIL, "|$mailprog -t -oi -oem") || &open_error($mailprog);
        print MAIL "Subject: $mail_subject\n";
        print MAIL "To: $FORM{'emailadd'}\n";
        print MAIL "From: $return_add\n\n";
#        print MAIL "CC:";

   print MAIL <<"PRINT_END_OF_MAIL";


Thank you for your entry to the 100 Links Page

Please return the favor and add a link to my 
100 Links Page from your pages. Copy the code 
below, and paste in an appropriate area of your page.
---------------

<A HREF="$Links_cgi">$page_title</A> 

PRINT_END_OF_MAIL

            ### *** DO NOT DISTURB THE LINE ABOVE *** ###

close (MAIL);

sleep(1);


                         ### *** *** ###

 }elsif (($operating_system eq '1') && ($remote_mail eq "1")) {          


                  ## THIS IS WINDOWS MAIL ##

$temp_msg = 'temp.mail';

open (MAIL, ">$temp_msg") || &open_error($temp_msg);
       
   print MAIL <<"PRINT_END_OF_MAIL";
To: $FORM{'emailadd'}
From: $return_add
Subject: $mail_subject

Thank you for your entry to the 100 Links Page

Please return the favor and add a link to my 
100 Links Page from your pages. Copy the code 
below, and paste in an appropriate area of your page.
---------------

<A HREF="$Links_cgi">$page_title</A> 

PRINT_END_OF_MAIL


close (MAIL);

if ($mailprog =~ /blat/i) {
system("blat.exe \"$temp_msg\" -s \"$mail_subject\" -f \"$return_add\" -t $FORM{'emailadd'}");
}
elsif ($mailprog =~ /windmail/i) {
system("\"$mailprog\" -t -t -n $temp_msg");
}
elsif ($mailprog =~ /imail/) {
system ("$mailprog -f $temp_msg -s \"$mail_subject\" -u $return_add -t $FORM{'emailadd'}");
}
unlink ("$temp_msg");

 }

             ### *** SEND MAIL TO WEBMASTER *** ###

if (($operating_system eq '0') && ($webmaster_mail eq "1")) {


        open (MAIL, "|$mailprog -t -oi -oem") || &open_error($mailprog);
        print MAIL "Subject: $mail_subject\n";
        print MAIL "To: $webmaster\n";
        print MAIL "From: $FORM{'emailadd'}\n\n";
#        print MAIL "CC:";

   print MAIL <<"PRINT_END_OF_MAIL";


Link Number: $link_number

$FORM{'sitename'}

$FORM{'disc'}

$FORM{'url'}

PRINT_END_OF_MAIL

            ### *** DO NOT DISTURB THE LINE ABOVE *** ###

close (MAIL);

sleep(1);


                         ### *** *** ###

}elsif (($operating_system eq '1') && ($webmaster_mail eq "1")) {            


                  ## THIS IS WINDOWS MAIL ##

$temp_msg = 'temp.mail';

open (MAIL, ">$temp_msg") || &open_error($temp_msg);
       
   print MAIL <<"PRINT_END_OF_MAIL";
To: $webmaster
From: $FORM{'emailadd'}
Subject: $mail_subject

Link Number: $link_number

$FORM{'sitename'}

$FORM{'disc'}

$FORM{'url'}

PRINT_END_OF_MAIL


close (MAIL);

if ($mailprog =~ /blat/i) {
system("blat.exe \"$temp_msg\" -s \"$mail_subject\" -f \"$return_add\" -t $webmaster");
}
elsif ($mailprog =~ /windmail/i) {
system("\"$mailprog\" -t -t -n $temp_msg");
}
elsif ($mailprog =~ /imail/) {
system ("$mailprog -f $temp_msg -s \"$mail_subject\" -u $return_add -t $webmaster");
}
unlink ("$temp_msg");

 }
} # End sub send_mail